/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.wahlvorschlagsperson;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.wahlvorschlagsperson.boundary.AbstractWahlvorschlagsPersonSearchParameters;
import de.ivu.elect.business.wahlvorschlagsperson.boundary.WahlvorschlagsPersonChangeEvent;
import de.ivu.elect.business.wahlvorschlagsperson.boundary.WahlvorschlagsPersonConversationStore;
import de.ivu.elect.business.wahlvorschlagsperson.boundary.WahlvorschlagsPersonExtendedDAO;
import de.ivu.elect.business.wahlvorschlagsperson.boundary.WahlvorschlagsPersonSearch;
import de.ivu.elect.business.wahlvorschlagsperson.boundary.WahlvorschlagsPersonSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPerson;
import de.ivu.elect.business.wahlvorschlagsperson.entity.WahlvorschlagsPersonMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractWahlvorschlagsPersonSearchView.COMPONENT_NAME)
@View(viewId = AbstractWahlvorschlagsPersonSearchView.VIEW_ID, useCase = UseCasePermission.WAHLVORSCHLAGS_PERSON_SEARCH)
public abstract class AbstractWahlvorschlagsPersonSearchView extends AbstractElectSearchView<WahlvorschlagsPerson> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlvorschlagsPersonSearchView";
  
  public static final String VIEW_ID = "/wahlvorschlagsperson/wahlvorschlags-person-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractWahlvorschlagsPersonSearchView requestHandler;

  @Inject
  private transient WahlvorschlagsPersonExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(WahlvorschlagsPersonConversationStore.class)
  protected transient WahlvorschlagsPersonConversationStore conversationStore;

  @Inject
  protected transient WahlvorschlagsPersonSearch search;

  @Inject
  @ConversationGroup(AbstractWahlvorschlagsPersonSearchParameters.class)
  protected transient WahlvorschlagsPersonSearchParameters searchParameters;

  @Inject
  protected transient WahlvorschlagsPersonMeta entityMeta;

  public AbstractWahlvorschlagsPersonSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public WahlvorschlagsPerson getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(WahlvorschlagsPerson entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public WahlvorschlagsPersonSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<WahlvorschlagsPerson> getEagerLoadingCollector() {
    return EagerLoadingCollector.<WahlvorschlagsPerson> create();
  }

  @Override
  public List<WahlvorschlagsPerson> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<WahlvorschlagsPerson> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onWahlvorschlagsPersonChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlvorschlagsPersonChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractWahlvorschlagsPersonSearchView {

    @View
    @Inject
    private transient Instance<AbstractWahlvorschlagsPersonSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractWahlvorschlagsPersonSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
